/*
	This file is part of the smb library
    Copyright (C) 1999  Nicolas Brodu
    brodu@iie.cnam.fr

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
    Boston, MA 02111-1307, USA.
*/
// SMBio manages the connections to a remote host

#ifndef __SESSIONIO_H__
#define __SESSIONIO_H__

#include "SessionPacket.h"
#include "NMBIO.h"

class SessionIO
{
protected:
	NMBIO nmbIO;
	char* ourNBName;
	char* hostNBName;
	char* hostName;
	int sock;
	int discardsock;
	int16 port;
	// Connects to host:port and return 0 on error, 1 otherwise
    int connect(const char *hostname, uint16 p=139);
    int connect(uint32 IP, uint16 p=139);
public:
	int errno;
	SessionIO();
	~SessionIO();
	// send the packet, #NbBytes sent returned, -1 on error & errorCode in errno
	int send(SessionPacket *p);
	SessionPacket *receive();   // ...
	// Returns -1 and a NetBIOS Session error code in errno on error
	int openSession(const char *hostname);
	int closeSession();
};

#endif //__SESSIONIO_H__
